#include "event_system.h"
#include <stdio.h>
#include <stdlib.h>

int main(void) {
  EventSystem *es = NULL;
  if (es_init(&es, 16, 64) != ES_INIT_SUCCESS) {
    printf("INITIALISATION FAILED\n");
    return 1;
  }

  for (int i = 0; i < 40; ++i) {
    Event ev = es_register_event(es);
    printf("%lu\n", ev.id);
  }

  printf("\n");

  unsigned int count = 6;

  for (int i = 0; i < count; ++i) {
    es_deregister_event(es, (Event){ .id = (i + 1) * 2 });
  }

  for (int i = 0; i < count; ++i) {
    Event ev = es_register_event(es);
    printf("%lu\n", ev.id);
  }

  es_deinit(&es);

  return 0;
}
